## librandomx 1.1.7

=== CMakeLists.txt ===
# Copyright (c) 2019, The Monero Project
# 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without modification, are
# permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice, this list of
#    conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright notice, this list
#    of conditions and the following disclaimer in the documentation and/or other
#    materials provided with the distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its contributors may be
#    used to endorse or promote products derived from this software without specific
#    prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
# THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
# THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 2.8.7)

project(RandomX)

set(randomx_sources
src/aes_hash.cpp
src/argon2_ref.c
src/argon2_ssse3.c
src/argon2_avx2.c
src/bytecode_machine.cpp
src/cpu.cpp
src/dataset.cpp
src/soft_aes.cpp
src/virtual_memory.cpp
src/vm_interpreted.cpp
src/allocator.cpp
src/assembly_generator_x86.cpp
src/instruction.cpp
src/randomx.cpp
src/superscalar.cpp
src/vm_compiled.cpp
src/vm_interpreted_light.cpp
src/argon2_core.c
src/blake2_generator.cpp
src/instructions_portable.cpp
src/reciprocal.c
src/virtual_machine.cpp
src/vm_compiled_light.cpp
src/blake2/blake2b.c)

if(NOT ARCH_ID)
  # allow cross compiling
  if(CMAKE_SYSTEM_PROCESSOR STREQUAL "")
    set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_HOST_SYSTEM_PROCESSOR})
  endif()
  string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" ARCH_ID)
endif()

if(NOT ARM_ID)
  set(ARM_ID "${ARCH_ID}")
endif()

if(NOT ARCH)
  set(ARCH "default")
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
  message(STATUS "Setting default build type: ${CMAKE_BUILD_TYPE}")
endif()

include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)

function(add_flag flag)
  string(REPLACE "-" "_" supported_cxx ${flag}_cxx)
  check_cxx_compiler_flag(${flag} ${supported_cxx})
  if(${${supported_cxx}})
    message(STATUS "Setting CXX flag ${flag}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}" PARENT_SCOPE)
  endif()
  string(REPLACE "-" "_" supported_c ${flag}_c)
  check_c_compiler_flag(${flag} ${supported_c})
  if(${${supported_c}})
    message(STATUS "Setting C flag ${flag}")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}" PARENT_SCOPE)
  endif()
endfunction()

# x86-64
if(ARCH_ID STREQUAL "x86_64" OR ARCH_ID STREQUAL "x86-64" OR ARCH_ID STREQUAL "amd64")
  list(APPEND randomx_sources
    src/jit_compiler_x86.cpp)

  if(MSVC)
    enable_language(ASM_MASM)
    list(APPEND randomx_sources src/jit_compiler_x86_static.asm)

    set_property(SOURCE src/jit_compiler_x86_static.asm PROPERTY LANGUAGE ASM_MASM)

    set_source_files_properties(src/argon2_avx2.c COMPILE_FLAGS /arch:AVX2)

    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/src/asm/configuration.asm
      COMMAND powershell -ExecutionPolicy Bypass -File h2inc.ps1 ..\\src\\configuration.h > ..\\src\\asm\\configuration.asm SET ERRORLEVEL = 0
      COMMENT "Generating configuration.asm at ${CMAKE_CURRENT_SOURCE_DIR}"
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/vcxproj)
    add_custom_target(generate-asm
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/asm/configuration.asm)
  else()
    list(APPEND randomx_sources src/jit_compiler_x86_static.S)

    # cheat because cmake and ccache hate each other
    set_property(SOURCE src/jit_compiler_x86_static.S PROPERTY LANGUAGE C)
    set_property(SOURCE src/jit_compiler_x86_static.S PROPERTY XCODE_EXPLICIT_FILE_TYPE sourcecode.asm)

    if(ARCH STREQUAL "native")
      add_flag("-march=native")
    else()
      # default build has hardware AES enabled (software AES can be selected at runtime)
      add_flag("-maes")
      check_c_compiler_flag(-mssse3 HAVE_SSSE3)
      if(HAVE_SSSE3)
        set_source_files_properties(src/argon2_ssse3.c COMPILE_FLAGS -mssse3)
      endif()
      check_c_compiler_flag(-mavx2 HAVE_AVX2)
      if(HAVE_AVX2)
        set_source_files_properties(src/argon2_avx2.c COMPILE_FLAGS -mavx2)
      endif()
    endif()
  endif()
endif()

# PowerPC
if(ARCH_ID STREQUAL "ppc64" OR ARCH_ID STREQUAL "ppc64le")
  if(ARCH STREQUAL "native")
    add_flag("-mcpu=native")
  endif()
  # PowerPC AES requires ALTIVEC (POWER7+), so it cannot be enabled in the default build
endif()

# ARMv8
if(ARM_ID STREQUAL "aarch64" OR ARM_ID STREQUAL "arm64" OR ARM_ID STREQUAL "armv8-a")
  list(APPEND randomx_sources
    src/jit_compiler_a64_static.S
    src/jit_compiler_a64.cpp)
  # cheat because cmake and ccache hate each other
  set_property(SOURCE src/jit_compiler_a64_static.S PROPERTY LANGUAGE C)
  set_property(SOURCE src/jit_compiler_x86_static.S PROPERTY XCODE_EXPLICIT_FILE_TYPE sourcecode.asm)

  # not sure if this check is needed
  include(CheckIncludeFile)
  check_include_file(asm/hwcap.h HAVE_HWCAP)
  if(HAVE_HWCAP)
    add_definitions(-DHAVE_HWCAP)
  endif()

  if(ARCH STREQUAL "native")
    add_flag("-march=native")
  else()
    # default build has hardware AES enabled (software AES can be selected at runtime)
    add_flag("-march=armv8-a+crypto")
  endif()
endif()

set(RANDOMX_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/src" CACHE STRING "RandomX Include path")

add_library(randomx ${randomx_sources})

if(TARGET generate-asm)
  add_dependencies(randomx generate-asm)
endif()

set_property(TARGET randomx PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET randomx PROPERTY CXX_STANDARD 11)
set_property(TARGET randomx PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET randomx PROPERTY PUBLIC_HEADER src/randomx.h)

include(GNUInstallDirs)
install(TARGETS randomx
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

add_executable(randomx-tests
  src/tests/tests.cpp)
target_link_libraries(randomx-tests
  PRIVATE randomx)
set_property(TARGET randomx-tests PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET randomx-tests PROPERTY CXX_STANDARD 11)

add_executable(randomx-codegen
  src/tests/code-generator.cpp)
target_link_libraries(randomx-codegen
  PRIVATE randomx)

set_property(TARGET randomx-codegen PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET randomx-codegen PROPERTY CXX_STANDARD 11)

if(NOT Threads_FOUND AND UNIX AND NOT APPLE)
  set(THREADS_PREFER_PTHREAD_FLAG ON)
  find_package(Threads)
endif()

add_executable(randomx-benchmark
  src/tests/benchmark.cpp
  src/tests/affinity.cpp)
target_link_libraries(randomx-benchmark
  PRIVATE randomx
  PRIVATE ${CMAKE_THREAD_LIBS_INIT})

include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
#include <cstdint>
#include <atomic>
int main() {
  std::atomic<uint64_t> a;
  a.is_lock_free();
}" HAVE_CXX_ATOMICS)

if(NOT HAVE_CXX_ATOMICS)
  target_link_libraries(randomx-benchmark
    PRIVATE "atomic")
endif()
set_property(TARGET randomx-benchmark PROPERTY POSITION_INDEPENDENT_CODE ON)
set_property(TARGET randomx-benchmark PROPERTY CXX_STANDARD 11)

=== debian/changelog ===
librandomx (1.1.7-4) unstable; urgency=medium

  * fix link with libatomic on armel/mipsel/powerpc;
    closes: bug#961100, thanks to Adrian Bunk

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 20 May 2020 11:24:40 +0200

librandomx (1.1.7-3) unstable; urgency=medium

  * declare compliance with Debian Policy 4.5.0
  * use debhelper compatibility level 12 (not 10);
    build-depend on debhelper-compat (not debhelper)

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 20 Mar 2020 14:47:37 +0100

librandomx (1.1.7-2) unstable; urgency=medium

  * re-release targeted unstable

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 14 Dec 2019 12:45:13 +0100

librandomx (1.1.7-1) experimental; urgency=low

  * initial release
    closes: bug#945953

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 02 Dec 2019 15:35:04 +0100

=== debian/control ===
Source: librandomx
Section: libs
Priority: optional
Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
Build-Depends:
 cmake,
 d-shlibs,
 debhelper-compat (= 12),
 pandoc <!nodoc>,
 pkg-kde-tools,
Standards-Version: 4.5.0
Homepage: https://github.com/tevador/RandomX
Vcs-Git: https://salsa.debian.org/cryptocoin-team/librandomx.git
Vcs-Browser: https://salsa.debian.org/cryptocoin-team/librandomx
Rules-Requires-Root: no

Package: librandomx0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: proof of work (PoW) algorithm for CPUs
 RandomX is a proof-of-work (PoW) algorithm
 that is optimized for general-purpose CPUs.
 RandomX uses random code execution (hence the name)
 together with several memory-hard techniques
 to minimize the efficiency advantage of specialized hardware.

Package: librandomx-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 librandomx0 (= ${binary:Version}),
 ${devlibs:Depends},
 ${misc:Depends},
Description: proof of work (PoW) algorithm for CPUs - development headers
 RandomX is a proof-of-work (PoW) algorithm
 that is optimized for general-purpose CPUs.
 RandomX uses random code execution (hence the name)
 together with several memory-hard techniques
 to minimize the efficiency advantage of specialized hardware.
 .
 This package provides development headers for RandomX.

=== debian/rules ===
#!/usr/bin/make -f

DH_OPTIONS = -O--buildsystem=cmake

# generate documentation unless nodoc requested
DOCS_stem = README doc/design doc/specs
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DOCS = $(foreach d,$(DOCS_stem),$d.html $d.txt)
endif

# avoid executable stack in assembly code
export DEB_CFLAGS_MAINT_APPEND = -Wa,--noexecstack

ifneq (,$(filter $(DEB_HOST_ARCH), armel mipsel powerpc))
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
override_dh_install: $(DOCS)
	dh_install
	d-shlibmove --commit \
		--devunversioned \
		--exclude-a \
		--exclude-la \
		--multiarch \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/*/*.so

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdocs:
	dh_installdocs --all -- $(DOCS)

override_dh_clean:
	dh_clean -- $(DOCS)

%.html: %.md
	pandoc --from gfm-raw_html --to html --standalone --output $@ $<

%.txt: %.md
	pandoc --from gfm-raw_html --to plain --output $@ $<

%:
	dh $@ --with pkgkde_symbolshelper $(DH_OPTIONS:-O%=%)

## librandomx 1.1.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -153,7 +153,7 @@
     src/jit_compiler_a64.cpp)
   # cheat because cmake and ccache hate each other
   set_property(SOURCE src/jit_compiler_a64_static.S PROPERTY LANGUAGE C)
-  set_property(SOURCE src/jit_compiler_x86_static.S PROPERTY XCODE_EXPLICIT_FILE_TYPE sourcecode.asm)
+  set_property(SOURCE src/jit_compiler_a64_static.S PROPERTY XCODE_EXPLICIT_FILE_TYPE sourcecode.asm)
 
   # not sure if this check is needed
   include(CheckIncludeFile)

=== debian/changelog ===
librandomx (1.1.9-1ubuntu1) jammy; urgency=medium

  * Adjust symbols for ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 10 Jan 2022 18:00:46 +0000

librandomx (1.1.9-1) unstable; urgency=medium

  [ upstrean ]
  * new release

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 26 Sep 2021 15:15:04 +0200

librandomx (1.1.8-3) unstable; urgency=medium

  * update symbols to cover ia64;
    closes: bug#995111, thanks to Age Bosma
  * update copyright info:
    + use Reference field (not License-Reference);
      tighten lintian overrides
    + update coverage
  * update git-buildpackage config:
    + use DEP-14 branches debian/latest upstream/latest
    + add usage comment

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 26 Sep 2021 15:10:34 +0200

librandomx (1.1.8-2) unstable; urgency=medium

  * update symbols file
  * declare compliance with Debian Policy 4.6.0
  * simplify source helper script copyright-check

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 10 Sep 2021 23:44:50 +0200

librandomx (1.1.8-1) experimental; urgency=medium

  [ upstrean ]
  * new release

  [ Jonas Smedegaard ]
  * use debhelper compatibility level 13 (not 12)
  * fix export DH_OPTIONS

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 09 Aug 2020 08:34:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: librandomx
 Section: libs
 Priority: optional
-Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
  cmake,
  d-shlibs,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  pandoc <!nodoc>,
  pkg-kde-tools,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/tevador/RandomX
 Vcs-Git: https://salsa.debian.org/cryptocoin-team/librandomx.git
 Vcs-Browser: https://salsa.debian.org/cryptocoin-team/librandomx

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-DH_OPTIONS = -O--buildsystem=cmake
+export DH_OPTIONS = -O--buildsystem=cmake
 
 # generate documentation unless nodoc requested
 DOCS_stem = README doc/design doc/specs
@@ -27,9 +27,6 @@
 		--movedev "debian/tmp/usr/include/*" usr/include/ \
 		debian/tmp/usr/lib/*/*.so
 
-override_dh_missing:
-	dh_missing --fail-missing
-
 override_dh_installdocs:
 	dh_installdocs --all -- $(DOCS)
 
@@ -43,4 +40,4 @@
 	pandoc --from gfm-raw_html --to plain --output $@ $<
 
 %:
-	dh $@ --with pkgkde_symbolshelper $(DH_OPTIONS:-O%=%)
+	dh $@ --with pkgkde_symbolshelper

## librandomx 1.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 # STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 # THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-cmake_minimum_required(VERSION 2.8.7)
+cmake_minimum_required(VERSION 3.5)
 
 project(RandomX)
 
@@ -108,6 +108,9 @@
 
     set_source_files_properties(src/argon2_avx2.c COMPILE_FLAGS /arch:AVX2)
 
+    set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /DRELWITHDEBINFO")
+    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /DRELWITHDEBINFO")
+
     add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/src/asm/configuration.asm
       COMMAND powershell -ExecutionPolicy Bypass -File h2inc.ps1 ..\\src\\configuration.h > ..\\src\\asm\\configuration.asm SET ERRORLEVEL = 0
       COMMENT "Generating configuration.asm at ${CMAKE_CURRENT_SOURCE_DIR}"

=== debian/changelog ===
librandomx (1.1.10-3) unstable; urgency=medium

  * Patch: Fixed GCC 13 compilation (Closes: #1037735)

 -- Bastian Germann <bage@debian.org>  Thu, 06 Jul 2023 18:16:38 +0200

librandomx (1.1.10-2) unstable; urgency=medium

  * Team upload

  [ Graham Inggs ]
  * Adjust librandomx0.symbols for ppc64el and s390x

 -- Bastian Germann <bage@debian.org>  Tue, 06 Sep 2022 17:33:22 +0200

librandomx (1.1.10-1) unstable; urgency=medium

  * Team upload
  * new release

 -- Bastian Germann <bage@debian.org>  Thu, 18 Aug 2022 23:11:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: librandomx
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
+Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
